# Orchid Information Manager
# This shows some credit information for the customer.
# Field 1 should be the Customer Number field.
from accpac import *
import eb
import datetime
import locale
import time

orders = None

# init is called when the script is first loaded.
def init(arg):
	pass

def accpacDateToDate(d):
	if d == "0":
		return None
	return datetime.date(int(d[0:4]), int(d[4:6]), int(d[6:8]))

def onRefreshContent():
	locale.setlocale(locale.LC_ALL, "")
	eb.clearAll()

	vARCBAL = openView("AR0160", 1)
	vARCBAL.recordClear()
	vARCBAL.put("IDCUST", eb.value1, False)
	vARCBAL.put("SWNOLIMIT", 1, False)
	vARCBAL.process()

	g = eb.addGrid()
	g.name = "grid"
	g.button1 = "Open"
	col = g.addColumn("")
	col = g.addColumn("")
	col.align = "RIGHT"

	r = g.addRow()
	r.setCell(0, "Outstanding A/R Balance")
	r.setCell(1, "{:,.2f}".format(vARCBAL.get("AMTBALCUST")))

	r = g.addRow()
	r.setCell(0, "A/R Pending Balance")
	r.setCell(1, "{:,.2f}".format(vARCBAL.get("AMTARPEND")))

	r = g.addRow()
	r.setCell(0, "O/E Pending Orders")
	vOEORDH = openView("OE0520", 1)
	vOEORDH.order(2) # customer, ordnumber
	vOEORDH.recordClear()
	vOEORDH.browse("CUSTOMER=\"" + eb.value1 + "\" AND TYPE=1 AND COMPLETE<3", True)
	tot = 0
	while vOEORDH.fetch() == 0:
		tot = tot + vOEORDH.get("INVNETWTX")
	r.setCell(1, "{:,.2f}".format(tot))
	r.setCellColor(0, RGB(0,0,255))
	r.setCellColor(1, RGB(0,0,255))

	r = g.addRow()
	r.setCell(0, "Other Pending Balance")
	r.setCell(1, "{:,.2f}".format(vARCBAL.get("AMTXXPEND")))

	r = g.addRow()
	r.setCell(0, "Total Outstanding Balance")
	r.setCell(1, "{:,.2f}".format(vARCBAL.get("AMTTOTCUST")))

	r = g.addRow()
	r.setCell(0, "Credit Limit")
	r.setCell(1, "{:,.2f}".format(vARCBAL.get("AMTLIMITC")))

	r = g.addRow()
	r.setCell(0, "Credit Limit Exceeded By")
	r.setCell(1, "{:,.2f}".format(vARCBAL.get("AMTOVERC")))

# Called when you double click / press enter on an item in the grid
def onAction_Open(ctrlName, rowIndex):
	rowIndex = int(rowIndex)
	if ctrlName == "ordergrid":
		openUI("OE1100", "KEY=" + str(orders[rowIndex]), False)
		return
	if rowIndex == 2: # O/E Pending Orders
		displayOrders()

# Button1 is the 'Open' button. It opens AR Customers.
def onAction_Button1(ctrlName):
	if ctrlName == "ordergrid":
		# The button is actually 'back', not 'open'
		onRefreshContent()
		return
	openUI("AR1700", "CUSTOMER=" + eb.value1, False)

def displayOrders():
	global orders
	eb.clearAll()
	vOEORDH = openView("OE0520", 2)
	vOEORDH.order(2) # customer, ordnumber
	vOEORDH.recordClear()
	vOEORDH.browse("CUSTOMER=\"" + eb.value1 + "\" AND TYPE=1 AND COMPLETE<3", True)

	g = eb.addGrid()
	g.name = "ordergrid"
	g.button1 = "Back"
	col = g.addColumn("Order Number")
	col = g.addColumn("Order Description")
	col = g.addColumn("Expected Ship Date")
	col = g.addColumn("Purchase Order Number")
	col = g.addColumn("Order Total")
	col.align = "RIGHT"
	n = 0
	orders = []
	while vOEORDH.fetch() == 0:
		n = n + 1
		r = g.addRow()
		r.setCell(0, vOEORDH.get("ORDNUMBER"))
		r.setCellColor(0, RGB(0,0,255))
		r.setCell(1, vOEORDH.get("DESC"))
		r.setCell(2, accpacDateToDate(vOEORDH.get("EXPDATE")).strftime("%x"))
		r.setCell(3, vOEORDH.get("PONUMBER"))
		r.setCell(4, "{:,.2f}".format(vOEORDH.get("INVNETWTX")))
		orders.append(vOEORDH.get("ORDUNIQ"))
